    function [ output_args ] = plotLayers(data, seg, layerSegs, layerSigns, varargin)
[numSamps, numProbes] = size(data.logRatios);

% sampVar = var(data.logRatiosSeg, [], 2);
sampVar = var(data.logRatios, [], 2);
% [~, sampI] = sort(data.subType1);
[~, sampI] = sort(sampVar);
% lr = data.logRatiosSeg(sampI, seg(1,1):seg(2,1));
lr = data.logRatios(sampI, seg(1,1):seg(2,1));

lrAgr = sum(data.logRatios);
lrAgrSeg = sum(data.logRatiosSeg);

% conv = updateScaleSpace(fieldParams, conv);
% scaleSpace = mapScaleSpace2probes(convInfo, conv, 0.05);

figure;
load './cmap_cgh.mat'
gca = subplot(3,1,1);
% imagesc(convInfo.probeLoc, 1:numSamps, lr);
imagesc(seg(1,1):seg(2,1), 1:numSamps, lr);
xlim([seg(1,1), seg(2,1)]);
% xlim([min(convInfo.probeLoc), max(convInfo.probeLoc)]);
axesPosition = get(gca, 'Position');
size(cmap)
colormap(cmap);
caxis([-1, 1]);
colorbar('EastOutside');
set(gca, 'Position', axesPosition);
freezeColors;
cbfreeze;

gca = subplot(3,1,2);
% plot(convInfo.probeLoc,  lrAgr, '.');
% xlim([min(convInfo.probeLoc), max(convInfo.probeLoc)]);
hold;
% h = plot(lrAgr, '.');
% set(h, 'MarkerSize', 8);
% plot(lrAgrSeg, 'r');
plot(lrAgr, 'r');
if length(varargin) ~= 0
    layerMus = varargin{1};
    plot([seg(1,1),seg(2,1)], [layerMus{1}(1), layerMus{1}(1)], 'k');
%     for i = 1:length(layerMus)
%         for j = 1:length(layerMus{i})
%             
%             try
%                 h = plot([layerSegs{i}(1,j), layerSegs{i}(2,j)], [layerMus{i}(j), layerMus{i}(j)], 'r');
%                 set(h, 'LineWidth', 2);
%             catch
%                 i
%                 j
%                 layerSegs{i}
%                 layerSegs{i}(1,j)
%                 layerSegs{i}(2,j)
%                 layerMus{i}(j)
%                 layerMus{i}(j)
%             end
%         end
%     end
%     plot([seg(1,1), seg(2,1)], [varargin{1}, varargin{1}])
end
plotChromBoundaries(data);
% [~, numSegsPos] = size(segsPos)
% [~, numSegsNeg] = size(segsNeg)
% for segI = 1:numSegsPos
%     h1 = plot([segsPos(1,segI)-0.5, segsPos(2,segI)+0.5], [1, 1], 'r');
%     set(h1, 'LineWidth', 8);
% end
% for segI = 1:numSegsNeg
%     h1 = plot([segsNeg(1,segI)-0.5, segsNeg(2,segI)+0.5], [-1, -1], 'g');
%     set(h1, 'LineWidth', 8);
% end

% plot([seg(1,1), seg(2,1)], [fieldParams.mu, fieldParams.mu], 'r');
xlim([seg(1,1), seg(2,1)]);
% lrAgrSegMu = mean(lrAgrSeg(seg(1,1):seg(2,1)));
lrAgrSegMu = mean(lrAgr(seg(1,1):seg(2,1)));
% lrAgrSegStd = std(lrAgrSeg(seg(1,1):seg(2,1)));
lrAgrSegStd = std(lrAgr(seg(1,1):seg(2,1)));
ymin = lrAgrSegMu -3*lrAgrSegStd;
ymax = lrAgrSegMu +3*lrAgrSegStd;
ylim([ymin, ymax]);
% ylim([min(lrAgrSeg(seg(1,1):seg(2,1))), max(lrAgrSeg(seg(1,1):seg(2,1)))]);
% set(gca,'XTick',[])

[layerSegs, layerSigns] =  reOrderLayers(data, layerSegs, layerSigns);




load './cmap_sig.mat'

gca = subplot(3,1,3);
plotSegs(seg, layerSegs, layerSigns);
plotChromBoundaries(data);
xlim([seg(1,1), seg(2,1)]);
ylim([-4, 4]);

end

function plotChromBoundaries(data)
    chromBounds = find(diff(data.chrom) ~= 0);
    for i = 1:length(chromBounds)
        plot([chromBounds(i), chromBounds(i)], [-100, 100], 'k');
    end
end

function plotSegs(seg, layerSegs, layerSigns)

hold;
for i = 1:length(layerSegs)
    [~, numSegs] = size(layerSegs{i});
    for j = 1:numSegs
        if layerSegs{i}(1,j) <= seg(2,1) && layerSegs{i}(2,j) >= seg(1,1)
            if layerSigns{i}(j) == 1
                h = plot([layerSegs{i}(1,j)-0.5, layerSegs{i}(2,j)+0.5], [i, i], 'r');
                    plot([layerSegs{i}(1,j)-0.5, layerSegs{i}(1,j)-0.5], [i-0.25, i+0.25], 'r');
                    plot([layerSegs{i}(2,j)+0.5, layerSegs{i}(2,j)+0.5], [i-0.25, i+0.25], 'r');
            else
                h = plot([layerSegs{i}(1,j)-0.5, layerSegs{i}(2,j)+0.5], [-i, -i], 'k');
                    plot([layerSegs{i}(1,j)-0.5, layerSegs{i}(1,j)-0.5], [-i-0.25, -i+0.25], 'k');
                    plot([layerSegs{i}(2,j)+0.5, layerSegs{i}(2,j)+0.5], [-i-0.25, -i+0.25], 'k');
            end
            set(h, 'LineWidth', 5);
        end
    end
end

end



function [layerSegsOut, layerSignsOut] = reOrderLayers(data, layerSegs, layerSigns)
    numLayers = length(layerSegs);
    layerSegsOut = cell(1, numLayers);
    layerSignsOut = cell(1, numLayers);
    for layerI = 1:numLayers
        segPos = [];
        segNeg = [];
        for layerJ = layerI:numLayers
            segPos = cat(2, segPos, layerSegs{layerJ}(:,layerSigns{layerJ} == +1));
            segNeg = cat(2, segNeg, layerSegs{layerJ}(:,layerSigns{layerJ} == -1));
        end
        probesPos = segs2probes(segPos);
        probesNeg = segs2probes(segNeg);
        segPos = probes2segsChromBound(data, probesPos);
        segNeg = probes2segsChromBound(data, probesNeg);
        
        [~, numPos] = size(segPos);
        [~, numNeg] = size(segNeg);
        
        layerSegsOut{layerI}    = cat(2, segPos, segNeg);
        layerSignsOut{layerI}   = cat(2, ones(1,numPos), -ones(1,numNeg));
        
        for layerJ = layerI:numLayers
            if ~isempty(layerSegs{layerJ}) && ~isempty(layerSegsOut{layerI})
                [~, startI] = intersect(layerSegs{layerJ}(1,:), layerSegsOut{layerI}(1,:));
                [~, endI] = intersect(layerSegs{layerJ}(2,:), layerSegsOut{layerI}(2,:));
                removeI = intersect(startI, endI);
                layerSegs{layerJ}(:,removeI) = [];
                layerSigns{layerJ}(removeI) = [];
            end    
        end
        
    end
    
    
end


function [segments] = probes2segs(probes)
    if isempty(probes)
        segments = [];
        return;
    end
    probesI = zeros(1, max(probes)+2);
    probesI(probes+1) = 1;
    probesDiff = diff(probesI);
    segments(1,:) = find(probesDiff == 1) + 1;
    segments(2,:) = find(probesDiff == -1);
    segments = segments - 1;
end

function [ probes ] = segs2probes( segments )
    probes = [];
    if isempty(segments)
        return;
    end
    numSegments = length(segments(1,:));
    for i = 1:numSegments
        probes = cat(2,probes, segments(1,i):segments(2,i));
    end
    probes = unique(probes);
end

function segs = probes2segsChromBound(data, probes)
segs = [];
chroms = unique(data.chrom);
for chrom = chroms
    currChromProbes = find(data.chrom == chrom);
    currProbes = intersect(currChromProbes, probes);
    if  ~isempty(currProbes)
        segs = cat(2, segs, probes2segs(currProbes));
    end   
end

end


