#include "mex.h"
#include <stdio.h>
#include <math.h>

int rnd(double number);

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]) {
    
	long int sampI, probeI, gI;
    int    numProbes, numSamps, numKernelSamps;
	double kernelT, kernelOffset;
	double *probeLoc, *profile, *mapLoc, *probeRange, *g, *kernel, *ProfileS;
	double *profileOut;
    double (*profileC)[2];
    double (*ProfileC)[2];
   
/*	Read input parameters */
    numProbes		= mxGetN(prhs[0]);
    probeLoc		= mxGetPr(prhs[0]);
	profile			= mxGetPr(prhs[1]);
	numSamps		= mxGetN(prhs[2]);
	mapLoc			= mxGetPr(prhs[2]);
	probeRange		= mxGetPr(prhs[3]);
	numKernelSamps	= mxGetN(prhs[4]);
	g				= mxGetPr(prhs[4]);
	kernel			= mxGetPr(prhs[5]);
	
	kernelT			= (double)(mxGetScalar(prhs[6]));
	kernelOffset	= (double)(mxGetScalar(prhs[7]));

/*	Create outout parameters */
	plhs[0]			= mxCreateDoubleMatrix(1, numSamps, mxREAL);
	ProfileS		= mxGetPr(plhs[0]);

/*	Convolution body */
	for (sampI = 0; sampI < numSamps; sampI++) {
		ProfileS[sampI] = 0.0;
		for (probeI = (long int)(rnd(probeRange[2*sampI]-1)); probeI < (long int)(rnd(probeRange[2*sampI+1])); probeI++) {
			gI = (long int)(rnd((probeLoc[probeI] -  mapLoc[sampI] + kernelOffset) / kernelT));
			ProfileS[sampI] += kernel[gI] * profile[probeI];
		}
	}    
    return;
}

int rnd(double number)
{
  return (number >= 0) ? (int)(number + 0.5) : (int)(number - 0.5);
}

